// Implementacin de un servidor que implementa  el servicio ECHO por
// el protocolo TCP (RCF 0862)
#include <sys/socket.h> // socket, send, recv...
#include <netinet/in.h> // sockaddr_in, htons, htonl, etc.
#include <arpa/inet.h>  // inet_addr
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

// Definir esta constante apropiadamente. Por ejemplo, usar las
// ltimas 4  5 cifras del DNI, para evitar que dos alumnos asignen
// el mismo nmero de puerto.
#define PUERTO ????
#define MAX_LINEA 80 // Maxima longitud esperada para una lectura

// Esta funcin crea el socket de escucha, le asigna el nmero de
// puerto y le pone en modo "listen". Retorna el socket creado.
// El cdigo de la funcin est ms abajo (despus del main())
int InicializarSocketEscucha(int puerto);

// Esta funcin hace una lectura del socket de datos, Si recibe cero,
// retorna cero. En otro caso, muestra por pantalla lo que ha recibido
// y lo enva de nuevo por el socket de datos, y retorna el nmero de
// caracteres enviados
int RecibirYEnviar(int socket_datos);

// Programa principal. 
// Crea un socket de escucha y queda a la espera de un cliente. Todo
// lo que reciba, lo envia de nuevo al cliente. Cuando el cliente
// cierre, cierra el socket de datos y queda a la espera de un nuevo
// cliente.
int main(int argc, char *argv[])
{
  int sockEscucha; // Socket por el que se esperan clientes
  int sockDatos;   // Socket por el que se reciben datos de los
                   // clientes y se enva la respuesta
  struct sockaddr_in dir_cliente;
  int long_dir_cliente=sizeof(dir_cliente);
  int recibidos; 
  

  // Informar al usuario del nmero de puerto que se usar
  printf("Servidor TCP: usando el puerto por defecto = % d\n", PUERTO);

  // Eliminar el buffer de printf, para que los printfs tengan efecto
  // inmediato y sea ms fcil depurar el programa
  // setvbuf(stdout, NULL, _IONBF, 0);
  
  sockEscucha=InicializarSocketEscucha(PUERTO);
  // Bucle infinito, se repite para cada cliente que llegue
  while (1) {
    // Esperar a que llegue un cliente
    printf("Esperando por clientes...");
    sockDatos=accept(sockEscucha, (struct sockaddr *) &dir_cliente, 
		     &long_dir_cliente);
    // Imprimimos informacin sobre el cliente que se ha conectado
    printf("Se ha conectado un cliente\n");
    // Imprimir la IP y el puerto del cliente:
    //    (A RELLENAR POR EL ALUMNO)
   
    // Mientras recibamos datos, le devolvemos el eco
    do {
      recibidos=RecibirYEnviar(sockDatos);
    } while (recibidos!=0);
    // Cuando se dejan de recibir datos, cerramos el socket de datos y
    // esperamos por otro cliente
    printf("El cliente ha cerrado\n");
    close(sockDatos);
  }
}

//================================================================
// Cdigo de las funciones auxiliares 
int InicializarSocketEscucha(int puerto)
{
  int ret;
  struct sockaddr_in dir;
  int socket_escucha;

  // Crear el socket
  socket_escucha=socket(PF_INET, SOCK_STREAM, 0);
  if (socket_escucha==-1) {
    perror("Al crear socket");
    exit(-1);
  }
  // Asignarle el numero de puerto
  dir.sin_family=AF_INET;
  dir.sin_port=htons(puerto);
  dir.sin_addr.s_addr=htonl(INADDR_ANY);
  ret=bind(socket_escucha,(struct sockaddr *)  &dir, sizeof(dir));
  if (ret==-1) {
    perror("Al asignar direccion");
    close(socket_escucha);
    exit(-1);
  }
  // Ponerlo en modo escucha
  ret=listen(socket_escucha, SOMAXCONN);
  if (ret==-1) {
    perror("Al poner en modo escucha");
    close(socket_escucha);
    exit(-1);
  }
  // El socket ya est preparado para hacer accept()
  return socket_escucha;
}

//================================================================
// La funcin que hace "echo"
// Recibe por el socket de datos, muestra lo recibido y lo reenva
int RecibirYEnviar(int socket_datos)
{
  int leidos; 
  char buffer[MAX_LINEA];

  // Recibir mensaje
  leidos=read(socket_datos, buffer, MAX_LINEA);
  if (leidos==0) return 0;

  // Mostrar informacin por pantalla
  printf("Recibido mensaje con %d caracteres\n", leidos);
  buffer[leidos]=0;  // Hay que aadir un terminador a la cadena, para
		     // poder imprimirla con %s
  printf("Mensaje: %s\n", buffer);

  // Devolver el mensaje
  write(socket_datos, buffer, leidos);
  // Observar que no escribo MAX_LINEA caracteres, sino solo los
  // "leidos"
  return leidos;
}
  
  
  
