// Implementacin de un servidor para probar el servicio ECHO,
// protocolo UDP (RCF 0862)
#include <sys/socket.h> // socket, send, recv...
#include <netinet/in.h> // sockaddr_in, htons, htonl, etc.
#include <arpa/inet.h>  // inet_addr
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

// Definir esta constante apropiadamente. Por ejemplo, usar las
// ltimas 4  5 cifras del DNI, para evitar que dos alumnos asignen
// el mismo nmero de puerto.
#define PUERTO ????
#define MAX_LINEA 80

// Esta funcin crea el socket de escucha, le asigna el nmero de
// puerto y le pone en modo "listen". Retorna el socket creado.
// El cdigo de la funcin est ms abajo (despus del main())
int InicializarSocketUDP(int puerto);

// Esta funcin intenta recvfrom del socket. Si no hay datos, se
// bloquear hasta que un ciente enve algo, y entonces mostrar por
// pantalla lo que ha recibido y se lo reenviar al cliente.
void RecibirYEnviar(int socket_datos);

// Programa principal. 
// Crea un socket UDP y entra en un bucle infinito en que llama a
// RecibirYEnviar una y otra vez.
int main(int argc, char *argv[])
{
  int  socketUDP;

  // Informar al usuario del nmero de puerto que se usar
  printf("Servidor UDP: usando el puerto por defecto = % d\n", PUERTO);

  // Eliminar el buffer de printf, para que los printfs tengan efecto
  // inmediato y sea ms fcil depurar el programa
  // setvbuf(stdout, NULL, _IONBF, 0);
  
  socketUDP=InicializarSocketUDP(PUERTO);

  while (1)   {
    printf("Esperando mensajes...");
    RecibirYEnviar(socketUDP);
  }
}

//================================================================
// Cdigo de las funciones auxiliares 
int InicializarSocketUDP(int puerto)
{
  int ret;
  struct sockaddr_in dir;
  int socket_UDP;

  // Crear el socket
  socket_UDP=socket(PF_INET, SOCK_DGRAM, 0); // DGRAM
  if (socket_UDP==-1) {
    perror("Al crear socket");
    exit(-1);
  }
  // Asignarle el numero de puerto
  dir.sin_family=AF_INET;
  dir.sin_port=htons(puerto);
  dir.sin_addr.s_addr=htonl(INADDR_ANY);
  ret=bind(socket_UDP,(struct sockaddr *)  &dir, sizeof(dir));
  if (ret==-1) {
    perror("Al asignar direccion");
    close(socket_UDP);
    exit(-1);
  }
  // NO SE HACE listen()
  // El socket ya est preparado para recibir
  return socket_UDP;
}

void RecibirYEnviar(int socket_udp)
{
  struct sockaddr_in dir_cliente;
  int long_dir_cliente=sizeof(dir_cliente);
  int leidos;
  char buffer[MAX_LINEA];

  leidos=recvfrom(socket_udp, buffer, MAX_LINEA, 0,
		  (struct sockaddr *)&dir_cliente, &long_dir_cliente);
  if (leidos<0) {
    perror("Al recibir");
    close(socket_udp);  exit(-1);
  }
  if (leidos==0) {
    printf("El cliente ha cerrado la conexin\n");
  } else {
    printf("Recibidos %d caracteres\n", leidos);
    // poner terminador al buffer para poder mostrarlo con %s
    buffer[leidos]=0;
    printf("Mensaje: %s\n", buffer);
    // Enviar de nuevo el mensaje al cliente
    sendto(socket_udp, buffer, leidos, 0, 
	   (struct sockaddr *) &dir_cliente, long_dir_cliente);
  }
}
